class Feld
{

  //--------------------------------------------------------------------------------------------------
  // Variabeln
  //--------------------------------------------------------------------------------------------------

  int FeldSpalte, FeldZeile;          // Spalten- bzw Zeilennummer des Feldes
  int FeldIndex;                      // Feldnummer
  
  // das Array "beeinflussendeZelle" enthlt die Indizes der Zellen mit Mittelpunkt im Feld selber 
  // oder in einem der acht benachbarten Feldern (dient der effizienteren Berhrungsabfrage)
  int [] beeinflussendeZelle = new int [AnzahlZellen]; 
  
  int AnzEinflusszellen;              // Anzahl eingeschriebene Zellen im Array

  //--------------------------------------------------------------------------------------------------
  // Konstruktoren
  //--------------------------------------------------------------------------------------------------

  Feld (int s, int z)                 // Parameter: Zeilen und Spaltennummer
  {
    FeldSpalte = s;
    FeldZeile = z;
    FeldIndex = FeldZeile * AnzSpalten + FeldSpalte;
    AnzEinflusszellen = 0;
  }

  //--------------------------------------------------------------------------------------------------
  // Methoden
  //--------------------------------------------------------------------------------------------------
  
  // schreibt den bergebenen Index in die nchste freie Stelle des Arrays

  void ZelleEinschreiben (int ZelleIndex)
  {
    beeinflussendeZelle [AnzEinflusszellen] = ZelleIndex;
    AnzEinflusszellen++;
  }

  //--------------------------------------------------------------------------------------------------
  // gibt die Anzahl Zellen im Array zurck

  int getAnzEinflusszellen ()
  {
    return AnzEinflusszellen;
  }

  //--------------------------------------------------------------------------------------------------  
  // gibt den Index der Zelle an der abgefragten Stelle im Array zurck
  int getBeeinflussendeZelle (int ArrayIndex)
  {
    return beeinflussendeZelle [ArrayIndex];
  }

  //--------------------------------------------------------------------------------------------------  

}
